import sys, threading, time
from PyQt5 import QtCore, QtGui, QtWidgets

qApp = QtWidgets.QApplication(sys.argv)

#setup some instances in the main thread
tv = QtWidgets.QTreeView()
m = QtGui.QStandardItemModel()
pm = QtGui.QPixmap(19,19)
pm2 = QtGui.QPixmap(20,20)
tv.setModel(m)
counter = 0

# some delegate. If you activate the print, then the python.exe crashes more often. - maybe not so relevant
class SomeDelegate(QtWidgets.QItemDelegate):
    runtimeUIDColumn=0
    def __init__(self, parent):
        QtWidgets.QItemDelegate.__init__(self, parent)
 
    def paint(self, painter, option, index):
        if not self.parent().indexWidget(index):
            item = index.model().itemFromIndex(index.sibling(index.row(), 0))
            try:
                #print (str(item.data(QtCore.Qt.UserRole)))
                pass
            except:
                pass
            QtWidgets.QItemDelegate.paint(self, painter, option, index)

#add a row to the treeview
def AddRow():
    global counter, m, pm2, pm
    counter = counter + 1
    row = [QtGui.QStandardItem("myItem " + str(counter)), QtGui.QStandardItem("myItem " + str(counter))]
    row[-1].setData(pm, QtCore.Qt.DecorationRole)
    m.appendRow(row)
    
#remove the first row and append a new row
def ChangeRows():
    global counter, m, pm2, pm
    counter = counter + 1
    m.invisibleRootItem().removeRow(0)
    row = [QtGui.QStandardItem("myItem " + str(counter)), QtGui.QStandardItem("myItem " + str(counter))]
    row[-1].setData(pm, QtCore.Qt.DecorationRole)
    m.invisibleRootItem().child(0).setData(pm2, QtCore.Qt.DecorationRole) # modify item from item model
    m.appendRow(row)

# initially add three rows
AddRow()
AddRow()
AddRow()
#activate delegate
tv.setItemDelegateForColumn(0, SomeDelegate(tv))

# separate thread to update the items
class MyThread(threading.Thread):
    def run(self):
        while (True):
            ChangeRows()
            ChangeRows()
            ChangeRows()
            time.sleep(0.001) # if you set to 0.001 then python.exe crashes more often
myThread=MyThread()
myThread.start()

#show and exec
tv.show()
qApp.exec_()